package bridge;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.Scanner;

class Pair {
    int to;
    int value;
    
    public Pair(int to, int value) {
        this.to = to;
        this.value = value;
    }
}

class Node implements Comparable<Node> {
    int rank = Integer.MAX_VALUE;
    int id;
    
    public Node(int id) {
        this.id = id;
    }
    
    @Override
    public int compareTo(Node other) {
        return rank - other.rank;
    }
}

class Road {
    int from, to, value;
    
    public Road(int from, int to, int value) {
        this.from = from;
        this.to = to;
        this.value = value;
    }
    
    @Override
    public boolean equals(Object obj) {
        Road r = (Road)obj;
        return r.to == to && r.from == from && r.value == value;
    }
    
    @Override
    public int hashCode() {
        //int result = 31 *
    }
}

public class Bridge {

    /*static void printGraph(ArrayList<LinkedList<Pair>> graph) {
        for (int i = 0; i < graph.size(); i++) {
            System.out.print(i + "-");
            for (Pair v : graph.get(i))
                System.out.print(v.to);
            System.out.println();
        }
    }*/
    
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
     
        int N = sc.nextInt();
        int Q = sc.nextInt();
        int type, x, y, value; 

        ArrayList<LinkedList<Pair>> graph = new ArrayList<>(N);
        for (int i = 0; i < N; i++)
            graph.add(new LinkedList<>());
        
        for (int i = 0; i < Q; i++) {
            type = sc.nextInt();
            if (type == 0) {
                x = sc.nextInt();
                y = sc.nextInt();
                value = sc.nextInt();
                graph.get(x).add(new Pair(y, value));
                graph.get(y).add(new Pair(x, value));
            }
            if (type == 1) {
                x = sc.nextInt();
                y = sc.nextInt();
                graph.get(x).remove(y);
                graph.get(y).remove(x);
            }
            if (type == 2) {
                x = sc.nextInt();
                y = sc.nextInt();
                
                PriorityQueue<Node> que = new PriorityQueue<>();
                boolean[] used = new boolean[N];
                Node[] nodes = new Node[N];
                int[] prev = new int[N];
                
                for (int j = 0; j < N; j++) {
                    nodes[j] = new Node(j);
                    prev[j] = -1;
                }
                
                used[x] = true;
                nodes[x].rank = 0;
                que.add(nodes[x]);
                boolean found = false;
                Node top = null;
                int tmp;
                
                while (!que.isEmpty()) {
                    top = que.poll();
                    if (top.id == y) {
                        found = true;
                        break;
                    }
                    for (Pair p : graph.get(top.id)) {
                        if (!used[p.to]) {
                            tmp = top.rank + p.value;
                            if (tmp < nodes[p.to].rank) {
                                used[p.to] = true;
                                nodes[p.to].rank = tmp;
                                que.add(nodes[p.to]);
                                prev[p.to] = top.id;
                            }
                        }
                    }
                }
                if (found) {
                    System.out.println(top.rank);
                }
                else System.out.println(-1);
            }
            //printGraph(graph);
        } 
    }
}
