package gump;

import java.util.Scanner;

class DisjoinSet {
    
    int[] par;
    int[] ranks;
    
    public DisjoinSet(int size) {
        par = new int[size];
        ranks = new int[size];
        
        for (int i = 0; i < size; i++) {
            par[i] = i;
            ranks[i] = 1;
        }
    }
    
    int find(int x) {
        return x == par[x] ? x : (x = find(par[x]));
    }
    
    void union(int x, int y) {
        int px = find(x);
        int py = find(y);
        
        if (px != py) {
            if (ranks[py] > ranks[px])
                par[px] = py;
            else {
                par[py] = px;
                if (ranks[py] == ranks[px])
                    ranks[py]++;
            }
        }
    }
    
    @Override
    public String toString() {
        String s = "";
        for (int i = 0; i < par.length; i++)
            s += par[i] + " ";
        return s;
    }
}

public class Gump {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        
        int tmp;
        for (int i = 0; i < n-1; i++)
            tmp = sc.nextInt();
        
        /*DisjoinSet set = new DisjoinSet(10);
        set.union(0,9);
        System.out.println(set);
        System.out.println(set.find(9));
        System.out.println(set);*/
        
    }  
}
